diff -ruN mldonkey-2.7.4-orig/src/daemon/common/commonMessages.ml mldonkey-2.7.4-mine/src/daemon/common/commonMessages.ml
--- mldonkey-2.7.4-orig/src/daemon/common/commonMessages.ml	2006-03-09 22:59:03.000000000 -0500
+++ mldonkey-2.7.4-mine/src/daemon/common/commonMessages.ml	2006-03-17 00:58:43.000000000 -0500
@@ -358,8 +358,7 @@
 table.downloaders { margin-right: auto; margin-left: auto; border: 1; border: @color_general_border@ solid 1px; }
 div.main { text-align: center; }
 table.main { margin-right: auto; margin-left: auto; }
-td.loaded{ padding-top: 0px; padding-bottom: 0px; background-color:@color_vd_downloaded@; font-size:1px; line-height: 2px; }
-td.remain{ padding-top: 0px; padding-bottom: 0px; background-color:@color_vd_remaining@; font-size:1px; line-height: 2px; }
+hr.loaded{ padding-top: 0px; padding-bottom: 0px; background-color: @color_vd_downloaded@; font-size:1px; }
 td.downloaded{ font-family: Verdana; font-weight: 500; font-size: 12px; color: @color_general_text@; }
 td.dl { white-space: nowrap; padding-top: 2px; padding-bottom: 2px; padding-left: 5px; padding-right: 5px; font-family: verdana; font-size: 10px; color: @color_general_text@;  }
 td.dlheader { cursor: pointer; color: @color_general_text@; font-family: Verdana, serif; font-size: 10px;
@@ -734,8 +733,7 @@
 body { background-color: #EAE8CF; color: #3F702E; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; margin: 2; }
 td,pre {color: #3F702E; font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px; }
 
-td.loaded { background-color: #6666cc; font-size: 2px; }
-td.remain { background-color: #cc6666; font-size: 2px; }
+hr.loaded{ padding-top: 0px; padding-bottom: 0px; background-color: #6666cc; font-size:1px; }
 
 a { text-decoration: none; font-weight: bold; }
 a:link,a:active,a:visited { color: #882222; }
@@ -897,9 +895,8 @@
 Download CSS
 body{ background-color:@color_vd_page_background@; color: @color_general_text@; }
 td,pre { color: @color_general_text@; }
-table.downloaders { border: @color_general_border@;}
-td.loaded{ background-color:@color_vd_downloaded@; }
-td.remain{ background-color:@color_vd_remaining@; }
+table.downloaders { border: @color_general_border@; }
+hr.loaded{ background-color: @color_vd_downloaded@; }
 td.downloaded{ color: @color_general_text@;}
 td.dl { color: @color_general_text@;  }
 td.dlheader { color: @color_general_text@;  
@@ -947,7 +944,6 @@
   color_chunk0: string;
   color_chunk1: string;
   color_vd_downloaded: string;
-  color_vd_remaining: string;
   color_general_text: string;
   color_general_border: string;
   color_anchor: string;
@@ -989,7 +985,6 @@
   color_chunk0 = "#000";
   color_chunk1 = "#000";
   color_vd_downloaded = "#000";
-  color_vd_remaining = "#000";
   color_general_text = "#000";
   color_general_border = "#000";
   color_anchor = "#000";
@@ -1032,7 +1027,6 @@
     color_chunk0 = "#F33"; 
     color_chunk1 = "#101077" ; 
     color_vd_downloaded = "#72AA72"; 
-    color_vd_remaining = "#EEE"; 
     color_general_text = "#000"; 
     color_general_border = "#000"; 
     color_anchor = "#000"; 
@@ -1072,7 +1066,6 @@
     color_chunk0 = "#DDD"; 
     color_chunk1 = "#FACD88" ; 
     color_vd_downloaded = "#FF9900"; 
-    color_vd_remaining = "#EEE";
     color_general_text = "#000"; 
     color_general_border = "#000"; 
     color_anchor = "#000"; 
@@ -1112,7 +1105,6 @@
     color_chunk0 = "#4DBCF0"; 
     color_chunk1 = "#48C1DC"; 
     color_vd_downloaded = "#63C3F0"; 
-    color_vd_remaining = "#EEE";
     color_general_text = "#000"; 
     color_general_border = "#000"; 
     color_anchor = "#000"; 
@@ -1152,7 +1144,6 @@
     color_chunk0 = "#9A77C0"; 
     color_chunk1 = "#AE8BD4"; 
     color_vd_downloaded = "#9054D1"; 
-    color_vd_remaining = "#EEE";
     color_general_text = "#000"; 
     color_general_border = "#000"; 
     color_anchor = "#000"; 
@@ -1192,7 +1183,6 @@
     color_chunk0 = "#989898"; 
     color_chunk1 = "#6C6C6C"; 
     color_vd_downloaded = "#424242"; 
-    color_vd_remaining = "#EEE";
     color_general_text = "#000"; 
     color_general_border = "#000"; 
     color_anchor = "#000"; 
@@ -1232,7 +1222,6 @@
     color_chunk0 = "#5668AB"; 
     color_chunk1 = "#C1CFE1"; 
     color_vd_downloaded = "#6476B9"; 
-    color_vd_remaining = "#EEE";
     color_general_text = "#000"; 
     color_general_border = "#000"; 
     color_anchor = "#000"; 
@@ -1272,7 +1261,6 @@
     color_chunk0 = "#5668AB"; 
     color_chunk1 = "#C1CFE1"; 
     color_vd_downloaded = "#6476B9"; 
-    color_vd_remaining = "#EEE";
     color_general_text = "#D4C9B7"; 
     color_general_border = "#000"; 
     color_anchor = "#000"; 
@@ -1312,7 +1300,6 @@
     color_chunk0 = "#989898"; 
     color_chunk1 = "#6C6C6C"; 
     color_vd_downloaded = "#424242"; 
-    color_vd_remaining = "#EEE";                    
     color_general_text = "#D4C9B7"; 
     color_general_border = "#000"; 
     color_anchor = "#000"; 
@@ -1352,7 +1339,6 @@
   "@color_chunk0@";
   "@color_chunk1@";
   "@color_vd_downloaded@";
-  "@color_vd_remaining@";
   "@color_general_text@";
   "@color_general_border@";
   "@color_anchor@";
@@ -1372,7 +1358,7 @@
   "@C12@";"@C13@";"@C14@";"@C15@";
   "@C16@";"@C17@";"@C18@";"@C19@";
   "@C20@";"@C21@";"@C22@";"@C23@";
-  "@C24@";"@C25@";"@C26@";"@C27@";
+  "@C24@";"@C26@";"@C27@";
   "@C28@";"@C29@";"@C30@";"@C31@";
   "@C32@";"@C33@";"@C34@";"@C35@";
   "@C36@"]
@@ -1406,7 +1392,6 @@
   | "@color_chunk0@" | "@C22@" -> style.color_chunk0
   | "@color_chunk1@" | "@C23@" -> style.color_chunk1
   | "@color_vd_downloaded@" | "@C24@" -> style.color_vd_downloaded
-  | "@color_vd_remaining@" | "@C25@" -> style.color_vd_remaining
   | "@color_general_text@" | "@C26@" -> style.color_general_text
   | "@color_general_border@" | "@C27@" -> style.color_general_border
   | "@color_anchor@" | "@C28@" -> style.color_anchor
diff -ruN mldonkey-2.7.4-orig/src/daemon/driver/driverInteractive.ml mldonkey-2.7.4-mine/src/daemon/driver/driverInteractive.ml
--- mldonkey-2.7.4-orig/src/daemon/driver/driverInteractive.ml	2006-03-09 22:59:03.000000000 -0500
+++ mldonkey-2.7.4-mine/src/daemon/driver/driverInteractive.ml	2006-03-16 19:26:29.000000000 -0500
@@ -452,15 +452,10 @@
             let downloaded = Int64.to_float file.file_downloaded in
             let size = if size < 1. then 1. else size in
             Printf.sprintf "%s \\<br\\>
-\\<table cellpadding=0 cellspacing=0 width=100%%\\>\\<tr\\>
-\\<td class=\\\"loaded\\\" style=\\\"height:%dpx\\\" width=\\\"%d%%\\\"\\> \\</td\\>
-\\<td class=\\\"remain\\\" style=\\\"height:%dpx\\\" width=\\\"%d%%\\\"\\> \\</td\\>
-\\</tr\\>\\</table\\>"
+\\<hr class=\\\"loaded\\\" size=%d width=\\\"%d%%\\\" align=\\\"left\\\" noshade\\>"
             (short_name file)
 	    (!!html_vd_barheight)
             (truncate (downloaded /. size *. 100.))
-	    (!!html_vd_barheight)
-            (truncate ( (1. -. downloaded /. size) *. 100.))
           );              	
 
           (Printf.sprintf "%5.1f" (percent file));
@@ -663,32 +658,22 @@
 	    (if !!html_mods_use_js_tooltips then
             Printf.sprintf "\\<TD onClick=\\\"location.href='submit?q=vd+%d';return true;\\\"
 			class=\\\"dl al\\\"\\>%s\\<br\\>
-	    		\\<table cellpadding=0 cellspacing=0 width=100%%\\>\\<tr\\>
-			\\<td class=\\\"loaded\\\" style=\\\"height:%dpx\\\" width=\\\"%d%%\\\"\\> \\</td\\>
-			\\<td class=\\\"remain\\\" style=\\\"height:%dpx\\\" width=\\\"%d%%\\\"\\> \\</td\\>
-			\\</tr\\>\\</table\\>\\</td\\>"
+			\\<hr class=\\\"loaded\\\" size=%d width=\\\"%d%%\\\" align=\\\"left\\\" noshade\\>\\</td\\>"
             file.file_num
             (short_name file)
 	    (!!html_vd_barheight)
             (truncate (downloaded /. size *. 100.))
-	    (!!html_vd_barheight)
-            (truncate ( (1. -. downloaded /. size) *. 100.))
 	 else
 	     Printf.sprintf "\\<TD onClick=\\\"location.href='submit?q=vd+%d';return true;\\\"
                         title=\\\"[File#: %d] [Net: %s]%s\\\" class=\\\"dl al\\\"\\>%s\\<br\\>
-                        \\<table cellpadding=0 cellspacing=0 width=100%%\\>\\<tr\\>
-                        \\<td class=\\\"loaded\\\" style=\\\"height:%dpx\\\" width=\\\"%d%%\\\"\\> \\</td\\>
-                        \\<td class=\\\"remain\\\" style=\\\"height:%dpx\\\" width=\\\"%d%%\\\"\\> \\</td\\>
-                        \\</tr\\>\\</table\\>\\</td\\>"
+								\\<hr class=\\\"loaded\\\" size=%d width=\\\"%d%%\\\" align=\\\"left\\\" noshade\\>\\</td\\>"
             file.file_num
             file.file_num
                         (net_name file)
                         (if !!max_name_len < String.length file.file_name then " " ^ file.file_name else "")
             (short_name file)
             (!!html_vd_barheight)
-            (truncate (downloaded /. size *. 100.))
-            (!!html_vd_barheight)
-            (truncate ( (1. -. downloaded /. size) *. 100.)));
+            (truncate (downloaded /. size *. 100.)));
           );
 
           (ctd file.file_num (size_of_int64 file.file_size));